apiv1/urls.py
from django.urls import path, include

from rest_framework.urlpatterns import format_suffix_patterns
from rest_framework.routers import DefaultRouter

from . import viewsets

router = DefaultRouter()
router.register(r'events', viewsets.EventViewset)
router.register(r'comments', viewsets.CommentViewset)
router.register(r'category', viewsets.CategoryViewset)
router.register(r'profile', viewsets.ProfileViewset)

app_name = 'apiv1'
urlpatterns = [
    path('', include(router.urls))
]

events/urls.py
from django.urls import path
from . import views

app_name = 'events'
urlpatterns = [
    path('', views.EventList.as_view(), name='event-list'),
    path('events/<int:pk>/', views.EventDetail.as_view(), name='event-detail'),
    path('events/new/', views.EventCreate.as_view(), name='event-create' ),
    path('events/<int:pk>/delete', views.EventDelete.as_view(), name='event-delete'),
    path('events/<int:pk>/update', views.EventUpdate.as_view(), name='event-update'),
    path('events/<event_id>/attend/', views.attend_event, name='attend_event'),
    path('events/<event_id>/not_attend/', views.not_attend_event, name='not_attend_event'),

]

meethub/urls.py
from django.contrib import admin
from django.urls import path, include
from django.conf import settings
from django.conf.urls.static import static

from filebrowser.sites import site

# from . import settings


urlpatterns = [
    path('iyanuashiri/', admin.site.urls),
    path('iyanuashiri/filebrowser/', site.urls),
    path('', include('events.urls'), name='events'),
    path('accounts/', include('accounts.urls')),
    path('tinymce/', include('tinymce.urls')),
    path('userprofile/', include('userprofile.urls'), name='userprofile'),
    path('notifications/', include('actions.urls')),
    path('comments/', include('comments.urls')),

    path('api/v1/', include('apiv1.urls')),

]

if settings.DEBUG:
    urlpatterns += static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)
    urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

userprofile/urls.py
from django.urls import path


from . import views


app_name = 'userprofile'
urlpatterns = [
    path('edit/', views.edit_profile, name='edit'),
    path('detail/<int:pk>/', views.UserDetail.as_view(), name='detail'),
]

userprofile/models.py
from django.db import models
from django.conf import settings
from django.shortcuts import reverse

from cloudinary.models import CloudinaryField

from events.models import Event
# Create your models here.


class Profile(models.Model):
    user = models.OneToOneField(settings.AUTH_USER_MODEL, on_delete=models.CASCADE)
    date_of_birth = models.DateField(blank=True, null=True)
    photo = CloudinaryField('image', blank=True, null=True)

    class Meta:
        verbose_name_plural = 'profiles'

    def __str__(self):
        return '{0}\'s profile'.format(self.user.username)

    def get_absolute_url(self):
        return reverse('userprofile:detail', kwargs={'pk': self.pk})

    def get_date_of_birth(self):
        return self.date_of_birth

    def is_attending(self):
        if Event.objects.filter(pk=self.pk, attendees=self.user).exists():
            return True

userprofile/forms.py
from django import forms
from django.contrib.auth.models import User

from .models import Profile


class UserForm(forms.ModelForm):

    class Meta:
        model = User
        fields = ('first_name', 'last_name', 'email')


class ProfileForm(forms.ModelForm):

    class Meta:
        model = Profile
        fields = ('date_of_birth', 'photo')

userprofile/views.py
from django.shortcuts import render
from django.views import generic
from django.contrib.auth.mixins import LoginRequiredMixin
from django.contrib.auth.models import User
from django.contrib.auth.decorators import login_required

from events.models import Event
from comments.models import Comment

from .forms import ProfileForm, UserForm
from .models import Profile


# Create your views here.

@login_required()
def edit_profile(request):

    # This line is a part of the connection to Cloudinary API
    context = dict(backend_form=ProfileForm())

    if request.method == 'POST':
        user_form = UserForm(instance=request.user, data=request.POST)
        profile_form = ProfileForm(instance=request.user.profile, data=request.POST, files=request.FILES)
        context['posted'] = profile_form.instance

        if user_form.is_valid() and profile_form.is_valid():
            user_form.save()
            profile_form.save()

    else:

        # This creates a profile for users that don't have a profile.
        # They didn't have a profile because they registered before the profile feature was added.
        # A profile is created for a user during the process of signup.

        Profile.objects.get_or_create(user=request.user)
        user_form = UserForm(instance=request.user)
        profile_form = ProfileForm(instance=request.user.profile)

    return render(request, 'userprofile/update_form.html', {'user_form': user_form, 'profile_form': profile_form})


class UserDetail(LoginRequiredMixin, generic.DetailView):
    model = User
    template_name = 'userprofile/profile_detail.html'
    context_object_name = 'user'

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        context['events'] = Event.objects.filter(creator=self.request.user)
        context['comments'] = Comment.objects.filter(created_by=self.request.user)
        return context

userprofile/templates/userprofile/profile_detail.html
{% extends 'events/base.html' %}
{% load static %}
{% load cloudinary %}
    {% block content %}
     <div class="shadow-lg p-3 mb-5 bg-light rounded">
        <div class="card">
            <div class="card-body">
                {% cloudinary user.profile.photo width=150 height=170 crop="fill" gravity='face' radius='max' %}

                <h2 class="card-text">{{ user.get_full_name }}</h2>
                <h4 class="card-text">{{ user.email }}</h4>
                <h1>{{ user.profile.date_of_birth }}</h1>
                <div class="d-flex justify-content-end">
                    <a class="btn btn-primary btn active" href="{% url 'userprofile:edit' %}">Edit Profile</a>
                </div>
            </div>
        </div>
     </div>

        {% for event in events %}
            <p></p>
            <div class="card w-75 mx-auto border-info">
                <div class="card-body">
                    <div>
                        <p class="card-text"><strong>{{ event.venue|upper }}</strong></p>
                        <h2><a class="card-text text-info" href="{% url 'events:event-detail' event.id %}">{{event.name}}</a></h2>
                        <p class="card-text"><small class="text-muted">{{ event.time }}</small></p>
                        <div>
                            <a href="{% url 'events:event-update' event.id %}" class="btn btn-primary btn-sm active">edit</a>
                            <a href="{% url 'events:event-delete' event.id %}" class="btn btn-danger btn-sm active">delete</a>
                        </div>
                    </div>
                </div>
            </div>

        {% endfor %}

    {% endblock %}

userprofile/templates/userprofile/update_form.html
{% extends 'events/base.html' %}
{% load static %}
{% load crispy_forms_filters %}
{% load cloudinary %}


{% block content %}
    <div class="mx-auto w-50">
        <h1>Edit your profile</h1>
        <form method="post" action="{% url 'userprofile:edit' %}" enctype="multipart/form-data">{% csrf_token %}
            {{ user_form|crispy }}
            {{ profile_form|crispy }}
            <button class="mx-auto btn btn-primary btn active w-25" type="submit">Save changes</button>
        </form>
    </div>
{% endblock %}